include "s1.inc"
include "Vram.inc"
include "VVram.inc"
include "Chars.inc"

ext AsciiPatternSource_, MonoPatternSource_, ColorPatternSource_
ext VVramFront_, RowFlags_

RowStep equ $0800
AsciiCount equ 64

dseg
Backup:
    defs VVramWidth*VVramHeight
AsciiPatternRam: public AsciiPatternRam
    defs CharHeight*2*AsciiCount
PatternRam: public PatternRam
    defs CharHeight*3*Char_End


zseg
charColor:
    defb 0
pColor:
pVram:
    defw 0
pFlsgs:
    defw 0
bits:
    defb 0
flagByte:
    defb 0


cseg
MakeDouble:
    ldb #$c0 | stb <bits
    clrb
    do
        lsla
        if cs
            orb <bits
        endif
        lsr <bits | lsr <bits
    while ne | wend
rts


; void InitAsciiPattern();
cseg
InitAsciiPattern_: public InitAsciiPattern_
    pshs a,b,x,y
        ldx #AsciiPatternSource_
        ldy #AsciiPatternRam
        ldd #CharHeight*AsciiCount
        do
            pshs a,b
                lda ,x+
                bsr MakeDouble
                stb ,y+
                bsr MakeDouble
                stb ,y+
            puls a,b
            subd #1
        while ne | wend
    puls a,b,x,y
rts


; void InitMonoPattern();
cseg
Colors:
    defb 4,05h
    defb 3,07h
    defb 1,06h
    defb 0
InitMonoPattern_: public InitMonoPattern_
    pshs a,b,x,y
        ldx #Colors | stx <pColor
        ldx #MonoPatternSource_
        ldy #PatternRam
        do
            pshs x
                ldx <pColor
                ldb ,x+
                stx <pColor
            puls x
            tstb
        while ne
            do
                pshs b
                    lda [pColor] | sta <charColor
                    ldb #3 ; plane count
                    do
                        pshs b
                            ldb #4 ; y count
                            do
                                pshs b
                                    clra
                                    ldb <charColor
                                    bitb #$01
                                    if ne
                                        ora ,x
                                    endif
                                    bitb #$10
                                    if ne
                                        ldb ,x
                                        cmpb
                                        pshs b
                                            ora ,s
                                        puls b
                                    endif
                                    bsr MakeDouble
                                    stb ,y+
                                    bsr MakeDouble
                                    stb ,y+

                                    leax 1,x
                                puls b
                                decb
                            while ne | wend
                            leax -4,x
                            lsr <charColor
                        puls b
                        decb
                    while ne | wend
                    leax 4,x
                puls b
                decb ; char count
            while ne | wend
            pshs x
                ldx <pColor
                leax 1,x
                stx <pColor
            puls x
        wend
    puls a,b,x,y
rts


; void InitColorPattern();
cseg
InitColorPattern_: public InitColorPattern_
    pshs a,b,x,y
        ldx #ColorPatternSource_
        ldy #PatternRam+CharHeight*3*Char_Enemy
        ldd #(Char_End-Char_Enemy)*CharHeight/2*3
        do
            pshs a,b
                lda ,x+
                bsr MakeDouble
                stb ,y+
                bsr MakeDouble
                stb ,y+
            puls a,b
            subd #1
        while ne | wend
    puls a,b,x,y
rts


; void ClearScreen();
cseg
ClearScreen_: public ClearScreen_
    pshs a,b,x,y
        lda #$07 | sta ACTIVE_PLANE
        ldx #Vram
        do
            clr ,x+
            cmpx #$4000
        while ne | wend

        ldx #Backup
        ldy #VVramWidth*VVramHeight
        do
            clr ,x+
            leay -1,y
        while ne | wend
    puls a,b,x,y
rts


cseg
Put8:
    lda #$01
    do
        sta ACTIVE_PLANE
        pshs a
            ldb #CharHeight
            do
                lda ,x+
                sta ,y
                leay RowStep,y
                decb
            while ne | wend
            leay -RowStep*CharHeight,y
        puls a
        lsla
        cmpa #$08
    while ne | wend
    leay RowStep*CharHeight,y
rts

Put4:
    lda #$01
    do
        sta ACTIVE_PLANE
        pshs a
            ldb #CharHeight/2
            do
                lda ,x+
                sta ,y
                leay RowStep,y
                decb
            while ne | wend
            leax CharHeight/2,x
            leay -RowStep*CharHeight/2,y
        puls a
        lsla
        cmpa #$08
    while ne | wend
    leay RowStep*CharHeight/2,y
rts

Clear8:
    lda #$07 | sta ACTIVE_PLANE
    ldb #CharHeight
    do
        clr ,y
        leay RowStep,y
        decb
    while ne | wend
rts

Clear4:
    lda #$07 | sta ACTIVE_PLANE
    ldb #CharHeight/2
    do
        clr ,y
        leay RowStep,y
        decb
    while ne | wend
rts


; word Put(word vram, byte c);
cseg
Put_: public Put_
    pshs a,b,x,y
        tfr x,y
        lda #PatternSize
        mul
        addd #PatternRam
        tfr d,x
        bsr Put8
    puls a,b,x,y
    tfr x,d
    addd #1
rts


VVramToVramRow:                             public VVramToVramRow
    ldb #VVramWidth/2
    do 
        pshs b
            ldd ,x++
            cmpd ,y
            if ne
                std ,y
                pshs x,y
                    ldy <pVram
                    tsta
                    if eq
                        bsr Clear8
                    else
                        pshs b
                            ldb #PatternSize
                            mul
                            ldx #PatternRam
                            leax d,x
                        puls b
                        tstb
                        if eq
                            bsr Put8
                            bra rowputend
                        endif
                        decb
                        if eq
                            bsr Clear4
                            bsr Put4
                            bra rowputend
                        endif
                        decb
                        if eq
                            leax CharHeight/2,x
                            bsr Put4
                            leax CharHeight*3*(4-1)-CharHeight/2,x
                            bsr Put4
                        else
                            leax CharHeight/2,x
                            bsr Put4
                            bsr Clear4
                        endif
                        rowputend:
                    endif
                    leay 1-RowStep*CharHeight,y
                    sty <pVram
                puls x,y
            else
                pshs y
                    ldy <pVram
                    leay 1,y
                    sty <pVram
                puls y
            endif
            leay 2,y
        puls b
        decb
    while ne | wend
    pshs y
        ldy <pVram
        leay VramRowSize-VVramWidth/2,y
        sty <pVram
    puls y
rts


; void VVramToVramAll();
VVramToVramAll_: public VVramToVramAll_
    pshs a,b,x,y
        ldy #Vram | sty <pVram
        ldx #VVramFront_
        ldy #Backup
        ldb #VVramHeight
        do
            pshs b
                bsr VVramToVramRow
            puls b
            decb
        while ne | wend
    puls a,b,x,y
rts


; void VVramToVramChanged();
VVramToVramChanged_: public VVramToVramChanged_
    pshs a,b,x,y
        ldx #RowFlags_ | stx <pFlsgs
        lda #$01 | sta <bits
        lda ,x+ | sta <flagByte
        stx <pFlsgs

        ldy #Vram | sty <pVram
        ldx #VVramFront_
        ldy #Backup
        ldb #VVramHeight
        do
            pshs b
                ldb <flagByte
                andb <bits
                if ne
                    bsr VVramToVramRow
                else
                    leax VVramWidth,x
                    leay VVramWidth,y
                    pshs x
                        ldx <pVram
                        leax VramRowSize,x
                        stx <pVram
                    puls x
                endif                    
                lsl <bits
                if eq
                    pshs a,x
                        ldx <pFlsgs
                        lda ,x+ | sta <flagByte
                        lda #$01 | sta <bits
                        stx <pFlsgs
                    puls a,x
                endif
            puls b
            decb
        while ne | wend

        clr RowFlags_+0
        clr RowFlags_+1
        clr RowFlags_+2
    puls a,b,x,y
rts


; word PrintC(word vram, byte c);
PrintC_: public PrintC_
    pshs x,y
        lda #$07 | sta ACTIVE_PLANE
        tfr x,y

        subb #$20
        lda #CharHeight*2
        mul
        addd #AsciiPatternRam
        tfr d,x
        ldb #CharHeight
        do
            lda ,x+ | sta ,y+
            lda ,x+ | sta ,y
            leay RowStep-1,y
            decb
        while ne | wend
    puls x,y
    tfr x,d
    addd #2
rts
